
//=================== ͷļ ==============================================
#include "AI8051U.H"
#include "intrins.h"

#include "monkey_16000_u8_mono.h"
#include "firecrackers_16000_u8_mono.h"
#include "boom_16000_u8_mono.h"

//=================== ʱӺͲʶ =================================
#define FOSC 40000000UL	 // ʱ
#define SampleRate 16000 // 

//=================== I2Sĺ궨 ==============================================
#define MCKOE 0 // I2Sʱ, 0:ֹI2Sʱ, 1:I2Sʱ

#define I2SEN 0x04 // I2Sģʹ, 0x00:ֹ, 0x04:
#define I2S_MODE 2 // I2Sģʽ, 0:ӻģʽ, 1:ӻģʽ, 2:ģʽ, 3:ģʽ,

#define PCMSYNC 0  // PCM֡ͬ, 0: ֡ͬ, 1: ֡ͬ
#define STD_MODE 0 // I2S׼ѡ, 0: I2Sֱ׼, 1: MSB׼, 2:LSBҶ׼, 3:PCM׼, CS4334CS4344ʹ0:I2Sֱ׼PT8211ʹ1: MSB׼
#define CKPOL 0	   // I2S̬ʱӼ, 0:ʱȶ״̬Ϊ͵ƽ, 1:ʱȶ״̬Ϊߵƽ
#define DATLEN 0   // ݳ, 0:16λ, 1:24λ, 2:32λ, 3:
#define CHLEN 0	   // ͨ(ÿƵͨλ), 0:16λ, 1: 32λ

#define I2S_MCLKDIV (FOSC / (8 * 16 * 2 * SampleRate)) // MCLKƵϵ, ˫16bit.
#define I2S_BCLKDIV (FOSC / (16 * 2 * SampleRate))	   // BCLKƵϵ, ˫16bit.

//===================  ==============================================
typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;

u16 firecrackers_index;
u16 monkey_index;
u16 boom_index;

bit firecrackers;
bit monkey;
bit boom;

u16 buffer[2];
bit flip;
bit flip_local;

//===================  ==============================================
void main(void)
{
	WTST = 0x00;
	CKCON = 0x00;
	EAXFR = 1;

	P0M0 = 0x00;
	P0M1 = 0x00;
	P1M0 = 0x00;
	P1M1 = 0x00;
	P2M0 = 0x00;
	P2M1 = 0x00;
	P3M0 = 0x00;
	P3M1 = 0x00;
	P4M0 = 0x00;
	P4M1 = 0x00;
	P5M0 = 0x00;
	P5M1 = 0x00;

	I2SMD = 0xff;							   // ڲֽ,ΪFFH
	I2SSR = 0x00;							   // ״̬Ĵ0
	I2SCR = 0x80 + 0x00;					   // ʹܷͻж(0x80), +0x00:Motorolaʽ, +0x10:TIʽ
	HSCLKDIV = 1;							   // ʱӷƵ 1~255 (Ĭ2)
	I2S_CLKDIV = 1;							   // I2SʱӷƵ
	I2SMCKDIV = I2S_MCLKDIV;				   // I2SʱӷƵI2SMCLK = Ƶ/2/I2S_CLKDIV/HSCLKDIV/I2SMCKDIV,  I2SMCLK = PLLCLK/2/I2S_CLKDIV/HSCLKDIV/I2SMCKDIV
	I2SPRH = (MCKOE << 1) + (I2S_BCLKDIV & 1); // I2S_BMCLKƵϵbit0, ֹMCLK
	I2SPRL = I2S_BCLKDIV / 2;				   // I2S_BMCLKƵϵbit8~bit1
	I2SCFGH = I2S_MODE;						   // I2SģʽΪģʽ
	I2SCFGL = (PCMSYNC << 7) + (STD_MODE << 4) + (CKPOL << 3) + (DATLEN << 1) + CHLEN;
	P_SW3 = (P_SW3 & 0x3f) | (2 << 6); // I2S˿л,
									   // 00: P3.2(BCLK) P3.3(MCLK) P3.4(SD) P3.5(LRCK),
									   // 01: P1.7(BCLK) P1.6(MCLK) P1.5(SD) P1.4(LRCK),
									   // 10: P2.3(BCLK) P2.2(MCLK) P2.1(SD) P2.0(LRCK),
									   // 11: P4.3(BCLK) P1.6(MCLK) P4.1(SD) P4.0(LRCK)
	I2SCFGH |= I2SEN; // ʹI2S

	monkey_index = 0;
	firecrackers_index = 0;
	boom_index = 0;

	monkey = 0;
	firecrackers = 0;
	boom = 0;

	flip = 0;
	flip_local = 0;

	IT0 = 1; // INT0 ½ж
	EX0 = 1; // ʹ INT0 ж
	EX2 = 1; // ʹ INT2 ж,ֻ½ش
	EX3 = 1; // ʹ INT3 ж,ֻ½ش

	EA = 1;

	while (1)
	{

		if (flip_local != flip)
		{
			buffer[flip_local] = 0;

			if (firecrackers) // С
			{
				buffer[flip_local] += firecrackers_16000_u8_mono_pcm[firecrackers_index++];
				if (firecrackers_index >= firecrackers_16000_u8_mono_pcm_len)
				{
					firecrackers_index = 0;
				}
			}

			if (monkey) // 
			{
				buffer[flip_local] += monkey_16000_u8_mono_pcm[monkey_index++];
				if (monkey_index >= monkey_16000_u8_mono_pcm_len)
				{
					monkey = 0;
					monkey_index = 0;
				}
			}

			if (boom) // 
			{
				buffer[flip_local] += (boom_16000_u8_mono_pcm[boom_index++] << 2);
				if (boom_index >= boom_16000_u8_mono_pcm_len)
				{
					boom = 0;
					boom_index = 0;
				}
			}
			flip_local = flip;
		}
	}
}

void interrupt0()
#ifdef __MODEL__
	interrupt INT0_VECTOR
#endif
{
	firecrackers = !firecrackers;
}

void interrupt2()
#ifdef __MODEL__
	interrupt INT2_VECTOR
#endif
{
	monkey = 1;
}

void interrupt3()
#ifdef __MODEL__
	interrupt INT3_VECTOR
#endif
{
	boom = 1;
}

//=================== I2SжϺ ==============================================
void I2S_ISR(void)
#ifdef __MODEL__
	interrupt I2S_VECTOR
#endif
{

	if (I2SSR & 0x02) // ͻ
	{
		if (I2SSR & 0x04) // 
		{
			u16 tmp = buffer[flip] << 6;
			I2SDRH = (u8)(tmp / 256); // һ֡Ƶ
			I2SDRL = (u8)(tmp % 256);
		}
		else // 
		{
			u16 tmp = buffer[flip] << 6;
			I2SDRH = (u8)(tmp / 256); // һ֡Ƶ
			I2SDRL = (u8)(tmp % 256);
			flip = !flip;
		}
	}
}
